#include "1-Wire.h"
#include "gpio.h"
#include "delays.h"

unsigned int One_Wire_Reset(unsigned int PINx)								
{
	unsigned int tmp;
	PIN_FLOAT_INPUT(PINx);
	if ((PIN_SYG(PINx))==0)	return One_Wire_Bus_Low_Error;
	PIN_OUT_PP(PINx);
	PIN_OFF(PINx);
	delay_us(Time_Reset_Low);
	PIN_ON(PINx);
	PIN_FLOAT_INPUT(PINx);
	delay_us(Time_Pulse_Delay_High);
	if ((PIN_SYG(PINx))==0) tmp=One_Wire_Success;
		else tmp=One_Wire_Error_No_Echo;
	delay_us(Time_After_Reset);
	return tmp;
}

void One_Wire_Write_Byte(unsigned char Byte, unsigned int PINx)
{
	unsigned char cnt;
	for (cnt=0;cnt!=8;cnt++) One_Wire_Write_Bit(Byte&(1<<cnt), PINx);
}

void One_Wire_Write_Bit (unsigned char Bit,unsigned int PINx)
{
	PIN_OUT_PP(PINx);
	PIN_OFF(PINx);
	if (Bit==0)
	{
		delay_us(Time_Pulse_Delay_High);
		PIN_ON(PINx);
		delay_us(Time_Pulse_Delay_Low);
	}
	else
	{
		delay_us(Time_Pulse_Delay_Low);
		PIN_ON(PINx);
		delay_us(Time_Pulse_Delay_High);
	}
	PIN_FLOAT_INPUT(PINx);
} 

unsigned char One_Wire_Read_Byte(unsigned int PINx)
{
	unsigned char tmp=0;
	unsigned char cnt;
	for (cnt=0;cnt!=8;cnt++)
		if (One_Wire_Read_Bit(PINx)!=0)	tmp|=(1<<cnt);
	delay_us(Time_Pulse_Delay_High);
	return tmp;
}

unsigned char One_Wire_Read_Bit (unsigned int PINx)
{
		unsigned char tmp;
	 	PIN_OUT_PP(PINx);
		PIN_OFF(PINx);
		delay_us(Time_Hold_Down);
		PIN_FLOAT_INPUT(PINx);
		delay_us(Time_Pulse_Delay_Low);
		if ((PIN_SYG(PINx))!=0)	tmp = 1;
			else tmp = 0;
		delay_us(Time_Pulse_Delay_High);
		return tmp;
}
