#include "DS1822.h"
#include <LPC21xx.H>
#include "Serial.h"

#define One_Wire_Pin	(1<<4)


//extern unsigned char DS1822_SERIAL_NUMBER[One_Wire_Device_Number_MAX][DS1822_SERIAL_NUM_SIZE];
extern unsigned char Search_Rom_SN[One_Wire_Device_Number_MAX][DS1822_SERIAL_NUM_SIZE];

int main(void)
{
	unsigned char cnt2=0;
	PINSEL0 = 0x00050000;           /* Enable RxD1 and TxD1                     */
	U1LCR = 0x83;                   /* 8 bits, no Parity, 1 Stop bit            */
	U1DLL = 82;                     /* 9600 Baud Rate @ 10MHz VPB Clock         */
	U1LCR = 0x03;                   /* DLAB = 0 								*/

	uart_print_string("LPC2101 1-Wire Test Starts...",1);

	if (DS1822_Search_Rom(&cnt2, One_Wire_Pin)!=One_Wire_Success)
	{	
		uart_print_string("ERROR Search ROM...",1);
		while(1);
	}
	uart_print_string("Found ",0);
	uart_print_value(cnt2);
	uart_print_string(" devices!",1);


	for (cnt2=0;cnt2!=One_Wire_Device_Number_MAX;cnt2++)
	{
		unsigned char cnt3;
		uart_print_string("Device ",0);
		uart_print_value(cnt2+1);
		uart_print_string(" serial number: ",0);
		for (cnt3=0;cnt3!=8;cnt3++)(uart_print_hex_value(Search_Rom_SN[cnt2][cnt3]));
		uart_print_string(" ",1);
	}
	

}
